<template lang="pug">
mixin prop(name, type)
  li
    strong.text-info= name
    if type
      span.text-muted= type
    span= ' : '
    block

Example(title='LineChart Example' :maxState="1")
  template(v-slot:description)
    h5 This is a Chart example
    p Click on #[em code] to view and modify its code.

  template(v-slot:interface)
    div #[strong Properties:]
      ul
        +prop("data", ": Array<number|any>")
          ul
            li plain Array of values to graph (no xAxis or yAxis needed)
            li Array of objects
        +prop("xAxis", ": string") xAxis property name (default: "key")
        +prop("yAxis", ": string|string[]|{[name: string]: string}")
          ul
            li yAxis property name (default: "value")
            li Array of yAxis property name (multi-graph)
            li Object with property names as key and legend as value
        +prop("yAxisRange", ': number[]') yAxis fixed range
        +prop("xAxisLabel", ": string") xAxis label string (default: no-label)
        +prop("yAxisLabel", ": string") yAxis label string (default: no-label)
        +prop("maxData", ": number") maximum data points in graph (only applied when calling add)
        +prop("smooth", ": boolean") disable/enable curved lines (default: true)
        +prop("isTimestamp", ": boolean") xAxis timestamp forced-mode

    div #[strong Methods:]
      ul
        +prop("add", "(value: any|any[])") add new values in chart
        +prop("redraw", "()") schedule graph redraw (if not paused)
        +prop("render", "()") run a graph render

    div #[strong Slots:]
      ul
        +prop("default") default slot with binding on "add" method

  template(v-slot:code)
    template(v-pre).
      div
        BaseLineChart(
            :data='[12, 13, 14, 10, 7, 18, 19, 20, 20, 20, 8, 7, 8, 9, 10]'
            :smooth='state === 0')
        BaseLineChart(:data='[12, 13, 14,12, 13, 14, 10 ]'
            yAxisLabel='Volts' xAxisLabel='measure' v-slot='chart')
          BaseInterval(:interval='1000' @tick='chart.add($butils.random(0, 20))')
        BaseLineChart(
            xAxis='date' :yAxisRange="[0, 100]" :yAxis="{ value1: 'first random value', value2: 'second random value' }"
            :smooth='state === 0' :isTimestamp='state === 0' v-slot='chart')
          BaseInterval(:interval='1000'
              @tick='chart.add({ date: Date.now(), value1: $butils.random(0, 90), value2: $butils.random(0, 20) })')
</template>
<script>
import Example from "./AppExample.vue";

export default {
  name: "ExampleLineChart",
  components: { Example }
};

</script>
